/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2018-2019 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by asn1tools version 0.145.2 Thu Jan 24 07:56:59 2019.
 */

#include <stdint.h>
#include <stdbool.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>

#include "files/c_source/address_book.h"
#include "files/c_source/scalar_value_types.h"

static void assert_first_encode(ssize_t res)
{
    if (res < 0) {
        printf("First encode failed with %ld.\n", res);
        __builtin_trap();
    }
}

static void test_address_book(
    const uint8_t *encoded_p,
    size_t size)
{
    ssize_t res;
    ssize_t i;
    uint8_t encoded[4096];
    uint8_t workspace[4096];
    struct address_book_address_book_t *decoded_p;
    
    decoded_p = address_book_address_book_new(&workspace[0],
                                              sizeof(workspace));

    if (decoded_p == NULL) {
        return;
    }

    res = address_book_address_book_decode(
        decoded_p,
        encoded_p,
        size);

    if (res >= 0) {
        res = address_book_address_book_encode(
            decoded_p,
            &encoded[0],
            sizeof(encoded));

        assert_first_encode(res);
    }
}

static void test_scalar_value_types(
    const uint8_t *encoded_p,
    size_t size)
{
    ssize_t res;
    ssize_t i;
    uint8_t encoded[4096];
    uint8_t workspace[4096];
    struct scalar_value_types_message_t *decoded_p;
    
    decoded_p = scalar_value_types_message_new(&workspace[0],
                                               sizeof(workspace));

    if (decoded_p == NULL) {
        return;
    }

    res = scalar_value_types_message_decode(
        decoded_p,
        encoded_p,
        size);

    if (res >= 0) {
        res = scalar_value_types_message_encode(
            decoded_p,
            &encoded[0],
            sizeof(encoded));

        assert_first_encode(res);
    }
}

int LLVMFuzzerTestOneInput(const uint8_t *data_p, size_t size)
{
    test_address_book(data_p, size);
    test_scalar_value_types(data_p, size);

    return (0);
}
